## allegro5 5.0.10

=== CMakeLists.txt ===
#
#
# TODO:
#
# - some documentation targets still missing
# - installing documentation
#

#-----------------------------------------------------------------------------#
#
#   Build system setup
#
#-----------------------------------------------------------------------------#

cmake_minimum_required(VERSION 2.6 FATAL_ERROR)
if(COMMAND cmake_policy)
    cmake_policy(SET CMP0003 NEW)
endif(COMMAND cmake_policy)

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE STRING
      "Choose the type of build, options are: None Debug Release RelWithDebInfo MinSizeRel Profile."
      FORCE)
endif()
# Restrict configuration types to the selected build type.
# Note: This needs to be done before the project command
set(CMAKE_CONFIGURATION_TYPES "${CMAKE_BUILD_TYPE}" CACHE INTERNAL "internal")

# Set the project name.
# We use C++ in a few cases.
project(ALLEGRO C CXX)

set(ALLEGRO_VERSION 5.0.10)
string(REGEX MATCH "^[0-9]+[.][0-9]+" ALLEGRO_SOVERSION ${ALLEGRO_VERSION})
string(REPLACE "." "" ALLEGRO_DLL_SHORTVER ${ALLEGRO_SOVERSION})

# Search in the `cmake' directory for additional CMake modules.
list(APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)

# Search in `deps' directories for dependency files.
file(GLOB deps_subdirs
    "${CMAKE_SOURCE_DIR}/deps"
    "${CMAKE_SOURCE_DIR}/deps/*"
    "${CMAKE_BINARY_DIR}/deps"
    "${CMAKE_BINARY_DIR}/deps/*"
    )
foreach(subdir ${deps_subdirs})
    if(EXISTS "${subdir}/include" OR EXISTS "${subdir}/lib")
        message(STATUS "Adding ${subdir} to CMAKE_FIND_ROOT_PATH")
        list(APPEND CMAKE_FIND_ROOT_PATH "${subdir}")
    endif()
endforeach(subdir)

# Search for C header files in these directories.
include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_BINARY_DIR}/include
    )

# Put libraries into `lib'.
set(LIBRARY_OUTPUT_PATH ${CMAKE_BINARY_DIR}/lib)

# Lists of all the source files.
include(FileList)

# Our own CMake macros and functions.
include(Common)

#-----------------------------------------------------------------------------#
#
#   Build options
#
#-----------------------------------------------------------------------------#

if(NOT IPHONE)
    option(SHARED "Build shared libraries" on)
    set(BUILD_SHARED_LIBS ${SHARED})    # actual CMake variable
endif(NOT IPHONE)

# On some 64-bit platforms, libraries should be installed into `lib64'
# instead of `lib'.  Set this to 64 to do that.
set(LIB_SUFFIX "" CACHE STRING "Suffix for 'lib' directories, e.g. '64'")

option(WANT_FRAMEWORKS "Want frameworks on Mac OS X" off)
option(WANT_EMBED
    "Make frameworks embeddable in application bundles (Mac OS X)" on)

set(FRAMEWORK_INSTALL_PREFIX "/Library/Frameworks" CACHE STRING
    "Directory in which to install Mac OS X frameworks")

#
# Platforms and drivers.
#

option(WANT_X11 "X11 support" on)
option(WANT_X11_XF86VIDMODE "X11 XF86VidMode Extension support" on)
option(WANT_X11_XINERAMA "X11 Xinerama Extension support" on)
option(WANT_X11_XRANDR "X11 XRandR Extension support" on)
option(WANT_D3D "Enable Direct3D graphics driver (Windows)" on)
option(WANT_D3D9EX "Enable Direct3D 9Ex extensions (Vista)" off)
option(WANT_OPENGL "Enable OpenGL graphics driver (Windows, X11, OS X))" on)

#
# Addons.
#

option(WANT_FONT "Enable bitmap font add-on" on)
option(WANT_AUDIO "Enable allegro_audio engine" on)
option(WANT_IMAGE "Enable image load/save addon" on)

if (NOT IPHONE)
    option(WANT_IMAGE_JPG "Enable JPEG support in image addon" on)
    option(WANT_IMAGE_PNG "Enable PNG support in image addon" on)
endif (NOT IPHONE)

option(WANT_TTF "Enable TTF addon" on)
option(WANT_COLOR "Enable color addon" on)
option(WANT_MEMFILE "Enable memfile addon" on)
option(WANT_PHYSFS "Enable PhysicsFS addon" on)
option(WANT_PRIMITIVES "Enable primitives addon" on)
option(WANT_NATIVE_DIALOG "Enable native dialog addon" on)

#
# Wrappers.
#

option(WANT_PYTHON_WRAPPER "Enable generation of the Python wrapper" off)

#
# Documentation.
#

option(WANT_DOCS "Generate documentation" on)
option(WANT_DOCS_HTML "Generate HTML documentation" on)
option(WANT_DOCS_MAN "Generate man pages" on)
option(WANT_DOCS_INFO "Generate Info document" off)
option(WANT_DOCS_PDF "Generate PDF document (requires pdflatex)" off)
option(WANT_DOCS_PDF_PAPER "Whether PDF output is destined for paper" off)

#
# For developers.
#

option(STRICT_WARN "Halt at warnings" off)
option(WANT_MUDFLAP "Enable gcc mudflap (requires gcc 4.0+)" off)

#
# Minor options.
#

if(NOT IPHONE)
    option(WANT_ALLOW_SSE "Allow compiler to use SSE instructions (x86)" on)
endif(NOT IPHONE)

option(NO_FPU "No floating point unit" off)
option(WANT_DLL_TLS "Force use of DllMain for TLS (Windows)" on)
option(WANT_DEMO "Build demo programs" on)
option(WANT_EXAMPLES "Build example programs" on)
option(WANT_POPUP_EXAMPLES "Use popups instead of printf for fatal errors" on)
option(WANT_TESTS "Build test programs" on)

#-----------------------------------------------------------------------------#
#
#   Set up compilers
#
#-----------------------------------------------------------------------------#

include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)

if(CMAKE_COMPILER_IS_GNUCC)
    set(COMPILER_GCC 1)
endif(CMAKE_COMPILER_IS_GNUCC)

if(WIN32)
    if(WANT_DLL_TLS AND SHARED)
        set(ALLEGRO_CFG_DLL_TLS 1)
    endif(WANT_DLL_TLS AND SHARED)
endif(WIN32)

if(MSVC)
    # MSVC never needs DLL TLS and it just confuses
    set(ALLEGRO_CFG_DLL_TLS 0)
    set(COMPILER_MSVC 1)
    set(ALLEGRO_MSVC 1)

    # Guess VCINSTALLDIR from the value of CMAKE_C_COMPILER if it's not set.
    # XXX CMAKE_C_COMPILER will often be simply "cl" so this won't work.
    if("$ENV{VCINSTALLDIR}" STREQUAL "")
        string(REGEX REPLACE "/bin/[^/]*$" "" VCINSTALLDIR "${CMAKE_C_COMPILER}")
        message(STATUS "Guessed MSVC directory: ${VCINSTALLDIR}")
    else("$ENV{VCINSTALLDIR}" STREQUAL "")
        file(TO_CMAKE_PATH "$ENV{VCINSTALLDIR}" VCINSTALLDIR)
        message(STATUS "Using VCINSTALLDIR: ${VCINSTALLDIR}")
    endif("$ENV{VCINSTALLDIR}" STREQUAL "")

    # Install in VCINSTALLDIR by default
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX ${VCINSTALLDIR}
            CACHE PATH "Install path prefix, prepended onto install directories."
            FORCE)
    endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

    set(EXECUTABLE_TYPE "WIN32")
endif(MSVC)

if(MINGW)
    # For alplatf.h
    set(ALLEGRO_MINGW32 1)

    # Guess MINGDIR from the value of CMAKE_C_COMPILER if it's not set.
    if("$ENV{MINGDIR}" STREQUAL "")
        string(REGEX REPLACE "/bin/[^/]*$" "" MINGDIR "${CMAKE_C_COMPILER}")
        message(STATUS "Guessed MinGW directory: ${MINGDIR}")
    else("$ENV{MINGDIR}" STREQUAL "")
        file(TO_CMAKE_PATH "$ENV{MINGDIR}" MINGDIR)
        message(STATUS "Using MINGDIR: ${MINGDIR}")
    endif("$ENV{MINGDIR}" STREQUAL "")

    # Search in MINGDIR for headers and libraries.
    set(CMAKE_PREFIX_PATH "${MINGDIR}")

    # Install to MINGDIR
    if(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
        set(CMAKE_INSTALL_PREFIX ${MINGDIR}
            CACHE PATH "Install path prefix, prepended onto install directories."
            FORCE)
    endif(CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)

    # Check for a common problem (at the time of writing).
    check_c_source_compiles("
        #include <windows.h>
        int main(void)
        {
            int x = DM_POSITION;
            return 0;
        }"
        HAVE_DM_POSITION)
    if(NOT HAVE_DM_POSITION)
        message(FATAL_ERROR
            "Missing DM_POSITION. Please update your MinGW "
            "w32api package, delete CMakeCache.txt and try again.")
    endif(NOT HAVE_DM_POSITION)
endif(MINGW)

if(UNIX AND NOT APPLE)
    set(ALLEGRO_UNIX 1)
endif(UNIX AND NOT APPLE)

if(APPLE AND NOT IPHONE)
    set(MACOSX 1)
endif(APPLE AND NOT IPHONE)

if(MACOSX)
    set(ALLEGRO_MACOSX 1)
    set(ALLEGRO_CFG_PTHREADS_TLS 1)
    set(ALLEGRO_UNIX 0)
    set(WANT_X11 off)

    # This flag is required on some versions of Mac OS X to avoid linker
    # problems with global variables which are not explicitly initialised.
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fno-common")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-common")
endif(MACOSX)

if(IPHONE)
    set(ALLEGRO_CFG_PTHREADS_TLS 1)
    set(ALLEGRO_IPHONE 1)
    set(ALLEGRO_UNIX 0)
    set(WANT_X11 off)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
    set(CMAKE_EXE_LINKER_FLAGS "-framework CoreGraphics -framework QuartzCore -framework UIKit -framework Foundation -framework CoreFoundation")
endif(IPHONE)

if(BORLAND)
    set(ALLEGRO_BCC32 1)
endif(BORLAND)

# Tell the compiler it can use SSE instructions on x86 architectures.
# If compatibility with Pentium 2's and below is required then the user
# should switch WANT_ALLOW_SSE off.

# Workaround for a possible bug in CMake.  Even if we set this variable in
# the toolchain file when cross-compiling, as we should, it is empty.
if(NOT CMAKE_SYSTEM_PROCESSOR AND CMAKE_SYSTEM_NAME STREQUAL Windows)
    set(CMAKE_SYSTEM_PROCESSOR i686)
endif()

if(CMAKE_SYSTEM_PROCESSOR MATCHES "i.86")
    set(ARCH_X86 1)
endif()
# CMake reports "x86" on my Windows Vista machine
if(CMAKE_SYSTEM_PROCESSOR MATCHES "x86")
    set(ARCH_X86 1)
endif()

if(ARCH_X86 AND WANT_ALLOW_SSE)
    if(COMPILER_GCC)
        message(STATUS "Allowing GCC to use SSE instructions")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse")
    endif(COMPILER_GCC)

    # Flags for other compilers should be added here.

    if(COMPILER_MSVC)
        message(STATUS "Allowing MSVC to use SSE instructions")
        set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} /arch:SSE")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /arch:SSE")
    endif(COMPILER_MSVC)
endif()

if(GP2XWIZ)
    set(ALLEGRO_GP2XWIZ 1)
    set(CMAKE_C_COMPILER "arm-openwiz-linux-gnu-gcc")
    set(CMAKE_CXX_COMPILER "arm-openwiz-linux-gnu-g++")
    set(CMAKE_SIZEOF_UNSIGNED_SHORT "2")
    set(WANT_X11 off)
    set(ALLEGRO_CFG_PTHREADS_TLS 1)
    set(SUPPORT_OPENGL 1)
    set(ALLEGRO_CFG_OPENGL 1)
    include_directories(SYSTEM ${CMAKE_FIND_ROOT_PATH}/include)
    link_directories(${CMAKE_FIND_ROOT_PATH}/lib)
    set(CMAKE_C_FLAGS_RELEASE "-mcpu=arm926ej-s -mtune=arm926ej-s -O3")
    set(CMAKE_CXX_FLAGS_RELEASE "-mcpu=arm926ej-s -mtune=arm926ej-s -O3")
    set(WANT_DEMO off)
endif(GP2XWIZ)

#-----------------------------------------------------------------------------#
#
#   Build types
#
#-----------------------------------------------------------------------------#

# Warnings.

if(STRICT_WARN)
    if(COMPILER_GCC)
        set(WFLAGS "-W -Wall -Werror -Wpointer-arith")
        set(WFLAGS_C_ONLY "-Wmissing-declarations -Wstrict-prototypes")
        if(ALLEGRO_UNIX)
            # Unfortunately we can't use this flag when magic main is used,
            # the mangled_main won't have a forward declaration.
            set(WFLAGS_C_ONLY "${WFLAGS_C_ONLY} -Wmissing-prototypes")
        endif(ALLEGRO_UNIX)
    endif(COMPILER_GCC)
    if(COMPILER_MSVC)
        set(WFLAGS "/W4 -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE")
    endif(COMPILER_MSVC)
else(STRICT_WARN)
    if(COMPILER_GCC)
        set(WFLAGS "-W -Wall")
    endif(COMPILER_GCC)
    if(COMPILER_MSVC)
        set(WFLAGS "/W3 -D_CRT_SECURE_NO_DEPRECATE -D_CRT_NONSTDC_NO_DEPRECATE")
    endif(COMPILER_MSVC)
endif(STRICT_WARN)

if(WIN32 AND COMPILER_GCC)
    # Helps to ensure the Windows port remains compatible with MSVC.
    set(WFLAGS_C_ONLY "${WFLAGS_C_ONLY} -Wdeclaration-after-statement")
endif(WIN32 AND COMPILER_GCC)

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${WFLAGS} ${WFLAGS_C_ONLY}")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${WFLAGS}")

if(WANT_MUDFLAP AND COMPILER_GCC)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fmudflapth")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fmudflapth")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fmudflapth -lmudflapth")

=== addons/CMakeLists.txt ===
# FOO_LINK_WITH and SUPPORT_FOO need to be propagated up to the parent scope so
# examples know if they can use the FOO addon, and what to link against.
# FOO_LINK_WITH should be the name of a single target.  The target should
# automatically pull in dependencies so they don't need to be listed.

include(FindPackageHandleStandardArgs)

set(ADDON_PKG_CONFIG_FILES)

if(WANT_PRIMITIVES)
    add_subdirectory(primitives)
    set(SUPPORT_PRIMITIVES 1)
    set(SUPPORT_PRIMITIVES 1 PARENT_SCOPE)
    set(PRIMITIVES_LINK_WITH ${PRIMITIVES_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_primitives)
endif(WANT_PRIMITIVES)

if(WANT_IMAGE)
    add_subdirectory(image)
    set(SUPPORT_IMAGE 1)
    set(SUPPORT_IMAGE 1 PARENT_SCOPE)
    set(IMAGE_LINK_WITH ${IMAGE_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_image)
endif(WANT_IMAGE)

if(WANT_FONT AND SUPPORT_IMAGE)
    add_subdirectory(font)
    set(SUPPORT_FONT 1)
    set(SUPPORT_FONT 1 PARENT_SCOPE)
    set(FONT_LINK_WITH ${FONT_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_font)
endif(WANT_FONT AND SUPPORT_IMAGE)

if(WANT_AUDIO)
    add_subdirectory(audio)
    if(SUPPORT_AUDIO)
        set(SUPPORT_AUDIO 1 PARENT_SCOPE)
        set(AUDIO_LINK_WITH ${AUDIO_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_audio)
    endif(SUPPORT_AUDIO)
endif(WANT_AUDIO)

if(SUPPORT_AUDIO)
    add_subdirectory(acodec)
    if(SUPPORT_ACODEC)
        set(SUPPORT_ACODEC 1 PARENT_SCOPE)
        set(ACODEC_LINK_WITH ${ACODEC_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_acodec)
    endif(SUPPORT_ACODEC)
endif(SUPPORT_AUDIO)

if(SUPPORT_FONT AND WANT_TTF)
    find_package(Freetype)
    if(FREETYPE_FOUND)
        add_subdirectory(ttf)
        set(SUPPORT_TTF 1 PARENT_SCOPE)
        set(TTF_LINK_WITH ${TTF_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_ttf)
    else(FREETYPE_FOUND)
        message("WARNING: FreeType not found, disabling support.")
    endif(FREETYPE_FOUND)
endif(SUPPORT_FONT AND WANT_TTF)

if(WANT_COLOR)
    add_subdirectory(color)
    set(SUPPORT_COLOR 1 PARENT_SCOPE)
    set(COLOR_LINK_WITH ${COLOR_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_color)
endif(WANT_COLOR)

if(WANT_MEMFILE)
    add_subdirectory(memfile)
    set(SUPPORT_MEMFILE 1 PARENT_SCOPE)
    set(MEMFILE_LINK_WITH ${MEMFILE_LINK_WITH} PARENT_SCOPE)
    list(APPEND ADDON_PKG_CONFIG_FILES allegro_memfile)
endif(WANT_MEMFILE)

if(WANT_PHYSFS)
    find_package(PhysFS)
    # FindPhysFS.cmake in cmake-2.6.2 doesn't call this but it should.
    find_package_handle_standard_args(PHYSFS DEFAULT_MSG
        PHYSFS_LIBRARY PHYSFS_INCLUDE_DIR)
    mark_as_advanced(PHYSFS_INCLUDE_DIR)
    mark_as_advanced(PHYSFS_LIBRARY)

    find_package(ZLIB)

    # Does this copy of PhysicsFS require zlib to be linked separately?
    # FindPhysFS should really figure this out for us, but it doesn't.
    if(PHYSFS_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${PHYSFS_INCLUDE_DIR})
        set(CMAKE_REQUIRED_LIBRARIES ${PHYSFS_LIBRARY})
        check_c_source_compiles("
            #include <physfs.h>

            int main(int argc, char **argv)
            {
                (void)argc;
                PHYSFS_init(argv[0]);
                PHYSFS_deinit();
                return 0;
            }"
            PHYSFS_IMPLICIT_ZLIB)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)

        if(PHYSFS_IMPLICIT_ZLIB)
            set(PHYSFS_LIBRARIES ${PHYSFS_LIBRARY})
            set(SUPPORT_PHYSFS 1)
        elseif(ZLIB_FOUND)
            set(PHYSFS_LIBRARIES ${PHYSFS_LIBRARY} ${ZLIB_LIBRARY})
            set(SUPPORT_PHYSFS 1)
        else()
            message("WARNING: PhysicsFS needs zlib, zlib not found, disabling PhysFS support.")
        endif()
    endif(PHYSFS_FOUND)

    if(SUPPORT_PHYSFS)
        add_subdirectory(physfs)
        set(SUPPORT_PHYSFS 1 PARENT_SCOPE)
        set(PHYSFS_LINK_WITH ${PHYSFS_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_physfs)
    endif(SUPPORT_PHYSFS)
endif(WANT_PHYSFS)

if(WANT_NATIVE_DIALOG)
    add_subdirectory(native_dialog)
    if(SUPPORT_NATIVE_DIALOG)
        set(SUPPORT_NATIVE_DIALOG 1 PARENT_SCOPE)
        set(NATIVE_DIALOG_LINK_WITH ${NATIVE_DIALOG_LINK_WITH} PARENT_SCOPE)
        list(APPEND ADDON_PKG_CONFIG_FILES allegro_dialog)
    endif()
endif(WANT_NATIVE_DIALOG)

add_subdirectory(main)
set(SUPPORT_ALLEGRO_MAIN ${SUPPORT_ALLEGRO_MAIN} PARENT_SCOPE)
set(ALLEGRO_MAIN_LINK_WITH ${ALLEGRO_MAIN_LINK_WITH} PARENT_SCOPE)
list(APPEND ADDON_PKG_CONFIG_FILES allegro_main)

set(ADDON_PKG_CONFIG_FILES ${ADDON_PKG_CONFIG_FILES} PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== docs/CMakeLists.txt ===
find_program(MAKEINFO NAMES makeinfo)
mark_as_advanced(MAKEINFO)

find_program(PANDOC NAMES pandoc)
mark_as_advanced(PANDOC)

# sh is only used for a developer-only target.
find_program(SH NAMES ash dash sh)
mark_as_advanced(SH)

find_package(LATEX)

find_program(CTAGS NAMES ctags)
mark_as_advanced(CTAGS)

#-----------------------------------------------------------------------------#

# Pandoc < 1.0 is usable but doesn't have Texinfo support.
if(PANDOC AND NOT DEFINED PANDOC_WITH_TEXINFO)
    message(STATUS "Checking Pandoc version")
    execute_process(
        COMMAND ${PANDOC} --version
        OUTPUT_VARIABLE PANDOC_VERSION_TEXT
        ERROR_VARIABLE PANDOC_VERSION_TEXT
        )
    if(PANDOC_VERSION_TEXT MATCHES "pandoc [1-9]")
        set(PANDOC_WITH_TEXINFO 1 CACHE BOOL "Pandoc supports Texinfo")
    else()
        set(PANDOC_WITH_TEXINFO 0 CACHE BOOL "Pandoc supports Texinfo")
    endif()
    mark_as_advanced(PANDOC_WITH_TEXINFO)
endif()

# Pandoc 1.2 and 1.2.1 accidentally changed the way it generates HTML
# identifiers.
if(PANDOC AND NOT DEFINED PANDOC_STRIP_UNDERSCORES)
    if(NOT PANDOC_VERSION_TEXT)
        execute_process(
            COMMAND ${PANDOC} --version
            OUTPUT_VARIABLE PANDOC_VERSION_TEXT
            ERROR_VARIABLE PANDOC_VERSION_TEXT
            )
    endif()
    if(PANDOC_VERSION_TEXT MATCHES "pandoc 1[.]2(\n|[.]1)")
        set(PANDOC_STRIP_UNDERSCORES 1 CACHE BOOL
            "Pandoc strips underscores for HTML identifiers")
    else()
        set(PANDOC_STRIP_UNDERSCORES 0 CACHE BOOL
            "Pandoc strips underscores for HTML identifiers")
    endif()
    mark_as_advanced(PANDOC_STRIP_UNDERSCORES)
endif()

# Pandoc 1.5 or later is required for LaTeX as it will begin
# sectioning with \chapter.
if(PANDOC AND NOT DEFINED PANDOC_FOR_LATEX)
    if(NOT PANDOC_VERSION_TEXT)
        execute_process(
            COMMAND ${PANDOC} --version
            OUTPUT_VARIABLE PANDOC_VERSION_TEXT
            ERROR_VARIABLE PANDOC_VERSION_TEXT
            )
    endif()
    if(PANDOC_VERSION_TEXT MATCHES "pandoc (0|1[.][01234])")
        set(PANDOC_FOR_LATEX 0 CACHE BOOL
            "Pandoc recent enough for LaTeX output")
    else()
        set(PANDOC_FOR_LATEX 1 CACHE BOOL
            "Pandoc recent enough for LaTeX output")
    endif()
    mark_as_advanced(PANDOC_FOR_LATEX)
endif()

#-----------------------------------------------------------------------------#

set(all_docs)

macro(add_info n)
    if(MAKEINFO)
        makedoc(src/${n}._tx -texi texi/${n}.texi)

        set(abs_info ${CMAKE_CURRENT_BINARY_DIR}/info/${n}.info)
        set(abs_texi ${CMAKE_CURRENT_BINARY_DIR}/texi/${n}.texi)

        list(APPEND all_docs ${abs_info})
        add_custom_command(
            OUTPUT  ${abs_info}
            DEPENDS ${abs_texi}
            COMMAND ${MAKEINFO} --no-split -o ${abs_info} ${abs_texi}
            )
    endif(MAKEINFO)
endmacro(add_info)

#-----------------------------------------------------------------------------#

function(pandoc source output) # extraargs...
    set(abs_source ${CMAKE_CURRENT_SOURCE_DIR}/${source})
    set(abs_output ${CMAKE_CURRENT_BINARY_DIR}/${output})

    # Use native Windows syntax to avoid "c:/foo.txt" being treated as a
    # remote URI by Pandoc 1.5 and 1.6.
    file(TO_NATIVE_PATH ${abs_source} abs_source_native)

    list(APPEND all_docs ${abs_output})
    set(all_docs ${all_docs} PARENT_SCOPE)

    add_custom_command(
        OUTPUT  ${abs_output}
        DEPENDS ${abs_source}
        COMMAND ${PANDOC} ${abs_source_native} --toc --standalone ${ARGN}
                -o ${abs_output}
        )
endfunction(pandoc source output)

function(texi2text source output)
    # The source file is a generated Texinfo file.
    set(abs_source ${CMAKE_CURRENT_BINARY_DIR}/${source})
    set(abs_output ${CMAKE_CURRENT_BINARY_DIR}/${output})

    list(APPEND all_docs ${abs_output})
    set(all_docs ${all_docs} PARENT_SCOPE)

    # Writing to stdout suppresses the table of contents.
    # To get the table of contents, use `makeinfo -o ${output}`.
    add_custom_command(
        OUTPUT  ${abs_output}
        DEPENDS ${abs_source}
        COMMAND ${MAKEINFO}
                --plaintext
                --paragraph-indent 0
                --no-number-sections
                ${abs_source} > ${abs_output}
        )
endfunction(texi2text)

if(PANDOC)
    pandoc(
        src/changes-5.0.txt
        html/changes-5.0.html
        -c pandoc.css
        )
endif(PANDOC)

if(PANDOC_WITH_TEXINFO)
    pandoc(
        src/changes-5.0.txt
        texi/changes-5.0.texi
        )
    if(MAKEINFO)
        texi2text(
            texi/changes-5.0.texi
            txt/changes-5.0.txt
            )
    endif(MAKEINFO)
endif(PANDOC_WITH_TEXINFO)

add_custom_target(docs
    ALL
    DEPENDS ${all_docs}
    )

#-----------------------------------------------------------------------------#

make_directory(${CMAKE_CURRENT_BINARY_DIR}/html/refman)
make_directory(${CMAKE_CURRENT_BINARY_DIR}/txt)
make_directory(${CMAKE_CURRENT_BINARY_DIR}/texi)

# Copy CSS files.
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/pandoc.css
    ${CMAKE_CURRENT_BINARY_DIR}/html/pandoc.css
    COPYONLY
    )
configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/pandoc.css
    ${CMAKE_CURRENT_BINARY_DIR}/html/refman/pandoc.css
    COPYONLY
    )

if(PANDOC AND NOT CMAKE_CROSSCOMPILING)
    include(Refman.cmake)
endif()

#-----------------------------------------------------------------------------#
# vim: set sts=4 sw=4 et:

=== examples/CMakeLists.txt ===
include_directories(
    ../addons/acodec
    ../addons/audio
    ../addons/color
    ../addons/font
    ../addons/image
    ../addons/main
    ../addons/memfile
    ../addons/native_dialog
    ../addons/physfs
    ../addons/primitives
    ../addons/ttf
    )

if(SUPPORT_PHYSFS)
    # The physfs example directly includes physfs.h
    include_directories(${PHYSFS_INCLUDE_DIR})
endif()

#-----------------------------------------------------------------------------#

# Conditionally build an example program.  If any of its arguments is the exact
# string "x", do nothing.  Otherwise strip off the "x" prefixes on arguments
# and call the example macro.
function(example name)
    set(is_console)
    set(args)
    foreach(arg ${ARGN})
        if(arg STREQUAL "x")
            message(STATUS "Not building ${name}")
            return()
        endif()
        if(arg STREQUAL "CONSOLE")
            set(is_console ON)
        else()
            string(REGEX REPLACE "^x" "" arg ${arg})
            list(APPEND args ${arg})
        endif()
    endforeach(arg)

    if(WIN32)
        if(is_console)
            # We need stdout and stderr available from cmd.exe,
            # so we must not use WIN32 here.
            set(EXECUTABLE_TYPE)
        else()
            set(EXECUTABLE_TYPE "WIN32")
        endif(is_console)
    endif(WIN32)

    if(IPHONE)
        set(EXECUTABLE_TYPE MACOSX_BUNDLE)
    endif(IPHONE)

    add_example(${name} ${args})
endfunction(example)

macro(add_example nm)
    if(WANT_POPUP_EXAMPLES AND SUPPORT_NATIVE_DIALOG)
        add_our_executable(${nm} ${ARGN} ${ALLEGRO_LINK_WITH} ${ALLEGRO_MAIN_LINK_WITH} ${NATIVE_DIALOG_LINK_WITH})
    else()
        add_our_executable(${nm} ${ARGN} ${ALLEGRO_LINK_WITH} ${ALLEGRO_MAIN_LINK_WITH} )
    endif()
endmacro(add_example nm)

#-----------------------------------------------------------------------------#

set(AUDIO x${AUDIO_LINK_WITH})
set(ACODEC x${ACODEC_LINK_WITH})
set(COLOR x${COLOR_LINK_WITH})
set(DIALOG x${NATIVE_DIALOG_LINK_WITH})
set(FONT x${FONT_LINK_WITH})
set(IMAGE x${IMAGE_LINK_WITH})
set(MEMFILE x${MEMFILE_LINK_WITH})
set(PHYSFS x${PHYSFS_LINK_WITH})
set(PRIM x${PRIMITIVES_LINK_WITH})
set(TTF x${TTF_LINK_WITH})

set(NIHGUI nihgui.cpp ${FONT} ${PRIM})

#-----------------------------------------------------------------------------#

example(ex_config)
example(ex_dir)
example(ex_file_slice CONSOLE)
example(ex_get_path)
example(ex_memfile CONSOLE ${MEMFILE})
example(ex_monitorinfo)
example(ex_path)
example(ex_path_test)
example(ex_user_events)

if(NOT MSVC)
    # UTF-8 strings are problematic under MSVC.
    example(ex_utf8)
endif(NOT MSVC)

example(ex_bitmap ${IMAGE})
example(ex_bitmap_flip ${IMAGE} ${FONT})
example(ex_bitmap_target ${FONT} ${IMAGE} ${PRIM})
example(ex_blend ${FONT} ${IMAGE} ${PRIM})
example(ex_blend2 ex_blend2.cpp ${NIHGUI} ${IMAGE})
example(ex_blend_bench ${IMAGE} ${PRIM})
example(ex_blend_test ${PRIM})
example(ex_blit ${FONT} ${IMAGE} ${COLOR})
example(ex_clip ${FONT} ${IMAGE} ${COLOR})
example(ex_color ex_color.cpp ${NIHGUI} ${TTF} ${COLOR})
example(ex_convert CONSOLE ${IMAGE})
example(ex_disable_screensaver ${FONT} ${IMAGE})
example(ex_display_events ${FONT} ${IMAGE} ${PRIM})
example(ex_display_options ${FONT} ${IMAGE} ${PRIM})
example(ex_draw ${FONT} ${IMAGE} ${COLOR} ${PRIM})
example(ex_draw_bitmap ${IMAGE} ${FONT})
example(ex_drawpixels)
example(ex_dualies ${IMAGE})
example(ex_expose ${IMAGE} ${PRIM})
example(ex_filter ${FONT} ${IMAGE} ${COLOR})
example(ex_fs_resize ${IMAGE} ${PRIM})
example(ex_fs_window ${IMAGE} ${PRIM} ${FONT})
example(ex_icon ${IMAGE})
example(ex_icon2 ${IMAGE})
example(ex_joystick_events ${PRIM})
example(ex_joystick_hotplugging ${PRIM})
example(ex_keyboard_events)
example(ex_keyboard_focus)
example(ex_lines ${PRIM})
example(ex_lockbitmap)
example(ex_membmp ${FONT} ${IMAGE})
example(ex_mouse ${IMAGE} ${PRIM})
example(ex_mouse_cursor ${FONT} ${IMAGE})
example(ex_mouse_events ${FONT} ${IMAGE} ${PRIM})
example(ex_mouse_focus)
example(ex_multisample ${FONT} ${COLOR} ${PRIM})
example(ex_multiwin ${IMAGE})
example(ex_nodisplay ${IMAGE})
example(ex_noframe ${IMAGE})
example(ex_physfs ${PHYSFS} ${IMAGE})
example(ex_pixelformat ex_pixelformat.cpp ${NIHGUI} ${IMAGE})
example(ex_premulalpha ${IMAGE} ${FONT})
example(ex_prim ${FONT} ${IMAGE} ${PRIM})
example(ex_resize ${PRIM})
example(ex_resize2 ${IMAGE})
example(ex_rotate ${IMAGE})
example(ex_scale ${IMAGE})
example(ex_subbitmap ${IMAGE} ${PRIM})
example(ex_threads ${PRIM})
example(ex_threads2)
example(ex_timedwait)
example(ex_timer ${FONT} ${IMAGE} ${PRIM})
example(ex_transform ${FONT} ${IMAGE} ${PRIM})
example(ex_vsync ${FONT} ${IMAGE})
example(ex_warp_mouse ${FONT} ${PRIM} ${IMAGE})
example(ex_windows ${FONT} ${IMAGE})
example(ex_winfull)

if(WANT_D3D AND D3DX9_FOUND)
    example(ex_d3d ex_d3d.cpp ${D3DX9_LIBRARY})
endif(WANT_D3D AND D3DX9_FOUND)

if(SUPPORT_OPENGL AND NOT IPHONE)
    example(ex_gldepth ${FONT} ${IMAGE})
    example(ex_glext)
    example(ex_opengl)
    example(ex_opengl_pixel_shader ${IMAGE})
endif(SUPPORT_OPENGL AND NOT IPHONE)

example(ex_font ${FONT} ${IMAGE})
example(ex_font_justify ex_font_justify.cpp ${NIHGUI} ${IMAGE} ${TTF})
example(ex_logo ${FONT} ${TTF} ${IMAGE} ${PRIM})
example(ex_ttf ${TTF} ${PRIM})

example(ex_acodec CONSOLE ${AUDIO} ${ACODEC})
example(ex_acodec_multi CONSOLE ${AUDIO} ${ACODEC})
example(ex_audio_chain ex_audio_chain.cpp ${AUDIO} ${ACODEC} ${PRIM} ${FONT} ${TTF})
example(ex_audio_props CONSOLE ex_audio_props.cpp ${NIHGUI} ${IMAGE} ${AUDIO} ${ACODEC})
example(ex_audio_simple CONSOLE ${AUDIO} ${ACODEC})
example(ex_audio_timer ${AUDIO} ${FONT})
example(ex_haiku ${AUDIO} ${ACODEC} ${IMAGE})
example(ex_kcm_direct CONSOLE ${AUDIO} ${ACODEC})
example(ex_mixer_chain CONSOLE ${AUDIO} ${ACODEC})
example(ex_mixer_pp ${AUDIO} ${ACODEC} ${PRIM} ${IMAGE})
example(ex_resample_test ${AUDIO})
example(ex_saw ${AUDIO})
example(ex_stream_file CONSOLE ${AUDIO} ${ACODEC})
example(ex_stream_seek CONSOLE ${AUDIO} ${ACODEC} ${PRIM} ${FONT} ${IMAGE})
example(ex_synth ex_synth.cpp ${NIHGUI} ${AUDIO} ${TTF})

example(ex_native_filechooser ${DIALOG} ${FONT} ${IMAGE} ${COLOR})

# In some configurations CURL pulls in dependencies which we don't check for.
# This example isn't important so it's disabled by default to prevent problems.
option(WANT_CURL_EXAMPLE "Build ex_curl example" off)
if(WANT_CURL_EXAMPLE)
    find_package(CURL)
    if(CURL_FOUND)
        if(WIN32)
            # select() is in the Winsock library.
            example(ex_curl ${CURL_LIBRARIES} ${IMAGE} ws2_32)
        else(WIN32)
            example(ex_curl ${CURL_LIBRARIES} ${IMAGE})
        endif(WIN32)
    endif(CURL_FOUND)
endif(WANT_CURL_EXAMPLE)

# Not yet added:
# ex_gp2x
# ex_iphone

# example(ex_ogre3d ex_ogre3d.cpp)
# include_directories(/usr/include/OGRE)
# target_link_libraries(ex_ogre3d OgreMain)

copy_data_dir_to_build(copy_example_data data .)

# This is useful for developers to add temporary test programs.
include(${CMAKE_CURRENT_SOURCE_DIR}/local_examples.cmake OPTIONAL)

#-----------------------------------------------------------------------------#
# vim: set ts=8 sts=4 sw=4 et:

=== tests/CMakeLists.txt ===
if(NOT ALLEGRO_LINK_WITH OR NOT ALLEGRO_MAIN_LINK_WITH OR
        NOT IMAGE_LINK_WITH OR NOT COLOR_LINK_WITH OR
        NOT FONT_LINK_WITH OR NOT TTF_LINK_WITH OR
        NOT PRIMITIVES_LINK_WITH)
    message(STATUS "Not building tests due to missing library. "
        "Have: ${ALLEGRO_LINK_WITH} ${ALLEGRO_MAIN_LINK_WITH} "
        "${IMAGE_LINK_WITH} ${COLOR_LINK_WITH} "
        "${FONT_LINK_WITH} ${TTF_LINK_WITH} "
        "${PRIMITIVES_LINK_WITH}")
    return()
endif()

include_directories(
    ../addons/acodec
    ../addons/audio
    ../addons/color
    ../addons/font
    ../addons/image
    ../addons/main
    ../addons/memfile
    ../addons/native_dialog
    ../addons/physfs
    ../addons/primitives
    ../addons/ttf
    )

if(MSVC)
    set(EXECUTABLE_TYPE)
endif(MSVC)

add_our_executable(
    test_driver
    ${ALLEGRO_LINK_WITH}
    ${ALLEGRO_MAIN_LINK_WITH}
    ${IMAGE_LINK_WITH}
    ${COLOR_LINK_WITH}
    ${FONT_LINK_WITH}
    ${TTF_LINK_WITH}
    ${PRIMITIVES_LINK_WITH}
    )

set(test_files
    ${CMAKE_CURRENT_SOURCE_DIR}/test_bitmaps.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_bitmaps2.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_blend.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_locking.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_locking2.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_backbuffer.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_image.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_fonts.ini
    ${CMAKE_CURRENT_SOURCE_DIR}/test_prim.ini
    )

add_custom_target(run_tests
    DEPENDS test_driver copy_example_data
    COMMAND test_driver ${test_files}
    )

add_custom_target(run_tests_gl
    DEPENDS test_driver copy_example_data
    COMMAND test_driver --force-opengl ${test_files}
    )

add_custom_target(run_tests_gl12
    DEPENDS test_driver copy_example_data
    COMMAND test_driver --force-opengl-1.2 ${test_files}
    )

add_custom_target(run_tests_gl20
    DEPENDS test_driver copy_example_data
    COMMAND test_driver --force-opengl-2.0 ${test_files}
    )

add_custom_target(run_tests_d3d
    DEPENDS test_driver copy_example_data
    COMMAND test_driver --force-d3d ${test_files}
    )

add_custom_target(run_tests_wine
    DEPENDS test_driver copy_example_data
    COMMAND wine test_driver ${test_files}
    )

add_custom_target(run_tests_wine_gl
    DEPENDS test_driver copy_example_data
    COMMAND wine test_driver --force-opengl ${test_files}
    )

# vim: set sts=4 sw=4 et:

=== addons/acodec/CMakeLists.txt ===
include_directories(../audio)

option(WANT_FLAC "Enable FLAC support" on)
option(WANT_VORBIS "Enable Ogg Vorbis support using libvorbis" on)
option(WANT_TREMOR "Enable Ogg Vorbis support using Tremor" off)
option(WANT_MODAUDIO "Enable MOD Audio support" on)
option(WANT_ACODEC_DYNAMIC_LOAD "Enable DLL loading in acodec (Windows)" on)

#-----------------------------------------------------------------------------#

set(ACODEC_INCLUDE_FILES
    allegro5/allegro_acodec.h
    )

set_our_header_properties(${ACODEC_INCLUDE_FILES})

set(ACODEC_SOURCES
    acodec.c
    wav.c
    helper.c
    )
set(ACODEC_LIBRARIES)

# For dynamic loading, we want to make sure that CMake has found an import
# library and not a static library. We assume that the name of the DLL to load
# is the same as the import library, bar the extension.
#
# With MSVC, static libraries and import libraries share the same extension.
# Luckily the MSVC static libraries for FLAC and Vorbis are named with a
# _static suffix.
# With MinGW, static libraries end with .a, and import libraries end with
# .dll.a so we can tell them apart. (The regex for this is a bodge.)
set(WIN32_STATIC_LIB_REGEX "_static[.]|[^l][.]a")

function(get_dll_name implib dllname_var)
    if(MINGW)
        # Guess the name of dlltool from gcc.
        string(REGEX REPLACE "gcc.*" dlltool DLLTOOL ${CMAKE_C_COMPILER})
        execute_process(
            COMMAND ${DLLTOOL} -I ${implib}
            OUTPUT_VARIABLE dllname
            OUTPUT_STRIP_TRAILING_WHITESPACE
            )
    elseif(MSVC)
        # Not sure this is the best way.
        execute_process(
            COMMAND lib /LIST ${implib}
            OUTPUT_VARIABLE output
            )
        if(output STREQUAL "")
            message("WARNING: Failed to execute lib /list")
        else()
            string(REGEX MATCH "[^\n]+[.]dll" dllname "${output}")
        endif()
    endif()
    if(NOT dllname)
        # Guess from the basename.
        get_filename_component(basename "${implib}" NAME_WE)
        set(dllname "${basename}.dll")
    endif()
    message(STATUS "DLL name for ${implib}: ${dllname}")
    set(${dllname_var} ${dllname} PARENT_SCOPE)
endfunction(get_dll_name)

#
# FLAC
#

if(WANT_FLAC)
    find_package(FLAC)
    if(FLAC_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${FLAC_INCLUDE_DIR})
        set(CMAKE_REQUIRED_LIBRARIES ${FLAC_LIBRARIES})
        check_c_source_compiles("
            #include <FLAC/stream_decoder.h>
            int main(void)
            {
                FLAC__StreamDecoderInitStatus status;
                return 0;
            }"
            FLAC_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(FLAC_COMPILES)
            set(SUPPORT_FLAC 1)
        endif(FLAC_COMPILES)
    endif(FLAC_FOUND)
    if(NOT SUPPORT_FLAC)
        message("WARNING: libFLAC not found or compile test failed, disabling support.")
    endif(NOT SUPPORT_FLAC)
endif(WANT_FLAC)

if(SUPPORT_FLAC)
    include_directories(SYSTEM ${FLAC_INCLUDE_DIR})
    set(ALLEGRO_CFG_ACODEC_FLAC 1)
    list(APPEND ACODEC_SOURCES flac.c)

    if(WIN32)
        option(FLAC_STATIC "Set this if linking with a static FLAC library" off)
        if(FLAC_STATIC)
            set(FLAC__NO_DLL "-DFLAC__NO_DLL")
        endif()

        if(NOT FLAC_STATIC AND FLAC_LIBRARY MATCHES "${WIN32_STATIC_LIB_REGEX}")
            set(FLAC_STATIC 1)
            set(FLAC__NO_DLL "-DFLAC__NO_DLL")
        endif()
        if(WANT_ACODEC_DYNAMIC_LOAD)
            if(FLAC_STATIC)
                message("WARNING: Dynamic loading will be disabled for FLAC as"
                        " static library was found: ${FLAC_LIBRARY}")
            else()
                get_dll_name(${FLAC_LIBRARY} ALLEGRO_CFG_ACODEC_FLAC_DLL)
            endif()
        endif()
    endif(WIN32)

    if(NOT ALLEGRO_CFG_ACODEC_FLAC_DLL)
        list(APPEND ACODEC_LIBRARIES ${FLAC_LIBRARIES})
    endif()
endif(SUPPORT_FLAC)

#
# MOD audio
#

if(WANT_MODAUDIO)
    find_package(DUMB)
    if(DUMB_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${DUMB_INCLUDE_DIR})
        set(CMAKE_REQUIRED_LIBRARIES ${DUMB_LIBRARIES})
        check_c_source_compiles("
            #include <dumb.h>
            int main(void)
            {
                dumb_register_stdfiles();
                return 0;
            }"
            DUMB_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(DUMB_COMPILES)
            set(SUPPORT_MODAUDIO 1)
        endif(DUMB_COMPILES)
    endif(DUMB_FOUND)
    if(NOT SUPPORT_MODAUDIO)
        message("WARNING: libdumb not found or compile test failed, "
                "disabling support. <http://dumb.sourceforge.net/>")
    endif(NOT SUPPORT_MODAUDIO)
endif(WANT_MODAUDIO)

if(SUPPORT_MODAUDIO)
    include_directories(SYSTEM ${DUMB_INCLUDE_DIR})
    set(ALLEGRO_CFG_ACODEC_MODAUDIO 1)
    list(APPEND ACODEC_SOURCES modaudio.c)

    if(WIN32 AND WANT_ACODEC_DYNAMIC_LOAD)
        if(DUMB_LIBRARY MATCHES "${WIN32_STATIC_LIB_REGEX}")
            message("WARNING: Dynamic loading will be disabled for DUMB"
                    " as static library was found: ${DUMB_LIBRARY}")
        else()
            get_dll_name(${DUMB_LIBRARY} ALLEGRO_CFG_ACODEC_DUMB_DLL)
        endif()
    endif()

    if(NOT ALLEGRO_CFG_ACODEC_DUMB_DLL)
        list(APPEND ACODEC_LIBRARIES ${DUMB_LIBRARIES})
    endif()
endif()

#
# Vorbis/Tremor
#

if(WANT_TREMOR)
    find_package(Tremor)
    if(TREMOR_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${TREMOR_INCLUDE_DIR})
        set(CMAKE_REQUIRED_LIBRARIES ${TREMOR_LIBRARIES})
        check_c_source_compiles("
            #include <tremor/ivorbisfile.h>
            int main(void)
            {
                OggVorbis_File f;
                ov_info(&f, -1);
                return 0;
            }"
            TREMOR_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(TREMOR_COMPILES OR IPHONE)
            set(SUPPORT_VORBIS 1)
        endif(TREMOR_COMPILES OR IPHONE)
    endif(TREMOR_FOUND)
    if(NOT SUPPORT_VORBIS)
        message("WARNING: Tremor not found although WANT_TREMOR was specified.")
    else(NOT SUPPORT_VORBIS)
        # mimic regular libogg/libvorbis
        set(OGG_INCLUDE_DIR ${TREMOR_INCLUDE_DIR})
        set(VORBIS_INCLUDE_DIR )
        set(VORBIS_LIBRARIES ${TREMOR_LIBRARIES})
        set(ALLEGRO_CFG_ACODEC_TREMOR 1)
    endif(NOT SUPPORT_VORBIS)
elseif(WANT_VORBIS)
    find_package(Vorbis)
    if(VORBIS_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${OGG_INCLUDE_DIR} ${VORBIS_INCLUDE_DIR})
        if(COMPILER_GCC)
            # libm is required when linking statically.
            set(CMAKE_REQUIRED_LIBRARIES "${VORBIS_LIBRARIES};m")
        else()
            set(CMAKE_REQUIRED_LIBRARIES "${VORBIS_LIBRARIES}")
        endif(COMPILER_GCC)
        check_c_source_compiles("
            #include <vorbis/vorbisfile.h>
            int main(void)
            {
                OggVorbis_File f;
                ov_callbacks callback;
                vorbis_info *v = 0;
                (void)v;
                ov_info(&f, -1);
                callback = OV_CALLBACKS_NOCLOSE;
                return 0;
            }"
            VORBIS_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(CMAKE_REQUIRED_LIBRARIES)
        if(VORBIS_COMPILES)
            set(SUPPORT_VORBIS 1)
        endif(VORBIS_COMPILES)
    endif(VORBIS_FOUND)
    if(NOT SUPPORT_VORBIS)
        message("WARNING: libvorbis not found or compile test failed, disabling support.")
    endif(NOT SUPPORT_VORBIS)
endif()

if(SUPPORT_VORBIS)
    include_directories(SYSTEM ${OGG_INCLUDE_DIR} ${VORBIS_INCLUDE_DIR})
    set(ALLEGRO_CFG_ACODEC_VORBIS 1)
    list(APPEND ACODEC_SOURCES ogg.c)

    if(WIN32 AND WANT_ACODEC_DYNAMIC_LOAD AND NOT WANT_TREMOR)
        if(VORBISFILE_LIBRARY MATCHES "${WIN32_STATIC_LIB_REGEX}")
            message("WARNING: Dynamic loading will be disabled for Vorbis"
                    " as static library was found: ${VORBISFILE_LIBRARY}")
        else()
            get_dll_name(${VORBISFILE_LIBRARY} ALLEGRO_CFG_ACODEC_VORBISFILE_DLL)
        endif()
    endif()

    if(NOT ALLEGRO_CFG_ACODEC_VORBISFILE_DLL)
        list(APPEND ACODEC_LIBRARIES ${VORBIS_LIBRARIES})
    endif()
endif(SUPPORT_VORBIS)

configure_file(
    allegro5/internal/aintern_acodec_cfg.h.cmake
    ${CMAKE_BINARY_DIR}/include/allegro5/internal/aintern_acodec_cfg.h
    )

add_our_library(allegro_acodec
    "${ACODEC_SOURCES};${ACODEC_INCLUDE_FILES}"
    "-DALLEGRO_ACODEC_SRC ${FLAC__NO_DLL}"
    "${AUDIO_LINK_WITH};${ACODEC_LIBRARIES}"
    )

set_our_framework_properties(allegro_acodec AllegroAcodec-${ALLEGRO_SOVERSION})

install_our_library(allegro_acodec)
install_our_headers(${ACODEC_INCLUDE_FILES})

set(ACODEC_LINK_WITH allegro_acodec PARENT_SCOPE)
set(SUPPORT_ACODEC 1 PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vim: set ts=8 sts=4 sw=4 et:

=== addons/audio/CMakeLists.txt ===
option(WANT_ALSA "Enable ALSA digital audio driver (Unix)" on)
option(WANT_OSS "Enable OSS digital audio driver (Unix)" on)
option(WANT_PULSEAUDIO "Enable PulseAudio audio driver (Unix)" on)
option(WANT_OPENAL "Enable OpenAL digital audio driver" on)
option(WANT_DSOUND "Enable DSound digital audio driver (Windows)" on)
option(WANT_AQUEUE "Enable AudioQueue digital audio driver (Mac)" on)

set(AUDIO_SOURCES
    audio.c
    audio_io.c
    kcm_dtor.c
    kcm_instance.c
    kcm_mixer.c
    kcm_sample.c
    kcm_stream.c
    kcm_voice.c
    )

set(AUDIO_INCLUDE_FILES allegro5/allegro_audio.h)

set_our_header_properties(${AUDIO_INCLUDE_FILES})

# The platform conditions are not really necessary but prevent confusing the
# user, e.g. it's pretty weird to get a warning about missing DSound on Unix.

if(WANT_OSS AND ALLEGRO_UNIX)
    include(AllegroFindOSS)
    if(OSS_FOUND)
        set(SUPPORT_OSS 1)
    endif(OSS_FOUND)
endif(WANT_OSS AND ALLEGRO_UNIX)

if(SUPPORT_OSS)
    set(ALLEGRO_CFG_KCM_OSS 1)
    list(APPEND AUDIO_SOURCES oss.c)
    set(SUPPORT_AUDIO 1)
endif(SUPPORT_OSS)

if(WANT_PULSEAUDIO AND ALLEGRO_UNIX)
    pkg_check_modules(PULSEAUDIO libpulse-simple)
    if(PULSEAUDIO_FOUND)
        set(CMAKE_REQUIRED_INCLUDES ${PULSEAUDIO_INCLUDE_DIRS})
        check_c_source_compiles("
            #include <pulse/simple.h>
            #include <pulse/error.h>
            #include <pulse/introspect.h>
            #include <pulse/mainloop.h>
            int main(void)
            {
                /* Require pulseaudio 0.9.15 */
                pa_context *c;
                pa_sink_info *si;
                pa_sink_state_t *ss;
                return 0;
            }"
            PULSEAUDIO_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(SUPPORT_PULSEAUDIO ${PULSEAUDIO_COMPILES})
        if(NOT SUPPORT_PULSEAUDIO)
            message("WARNING: PulseAudio compile test failed, disabling support")
        endif()
    endif(PULSEAUDIO_FOUND)
endif(WANT_PULSEAUDIO AND ALLEGRO_UNIX)

if(SUPPORT_PULSEAUDIO)
    set(ALLEGRO_CFG_KCM_PULSEAUDIO 1)
    list(APPEND AUDIO_SOURCES pulseaudio.c)
    list(APPEND AUDIO_LIBRARIES ${PULSEAUDIO_LIBRARIES})
    include_directories(SYSTEM ${PULSEAUDIO_INCLUDE_DIRS})
    link_directories(${PULSEAUDIO_LIBRARY_DIRS})
    set(SUPPORT_AUDIO 1)
endif(SUPPORT_PULSEAUDIO)

if(WANT_ALSA AND ALLEGRO_UNIX)
    pkg_check_modules(ALSA alsa)
    if(ALSA_FOUND)
        set(SUPPORT_ALSA 1)
    endif(ALSA_FOUND)
endif(WANT_ALSA AND ALLEGRO_UNIX)

if(SUPPORT_ALSA)
    set(ALLEGRO_CFG_KCM_ALSA 1)
    list(APPEND AUDIO_SOURCES alsa.c)
    list(APPEND AUDIO_LIBRARIES ${ALSA_LIBRARIES})
    include_directories(SYSTEM ${ALSA_INCLUDE_DIRS})
    set(SUPPORT_AUDIO 1)
endif(SUPPORT_ALSA)

if(WANT_DSOUND AND WIN32)
    find_package(DSound)
    if(DSOUND_FOUND)
        set(SUPPORT_DSOUND 1)
    endif(DSOUND_FOUND)
endif(WANT_DSOUND AND WIN32)

if(SUPPORT_DSOUND)
    set(ALLEGRO_CFG_KCM_DSOUND 1)
    list(APPEND AUDIO_SOURCES dsound.cpp)
    list(APPEND AUDIO_LIBRARIES ${DSOUND_LIBRARIES})
    include_directories(SYSTEM ${DSOUND_INCLUDE_DIR})
    set(SUPPORT_AUDIO 1)
endif(SUPPORT_DSOUND)

if(WANT_AQUEUE AND MACOSX)
    # Should check the presence just to be sure.
    find_library(AUDIO_TOOLBOX_LIB NAMES AudioToolbox)
    if(AUDIO_TOOLBOX_LIB)
        find_path(AQUEUE_INCLUDE_DIR AudioToolbox/AudioQueue.h)
        if(AQUEUE_INCLUDE_DIR)
            set(SUPPORT_AQUEUE 1)
        endif(AQUEUE_INCLUDE_DIR)
    endif(AUDIO_TOOLBOX_LIB)

    if(NOT SUPPORT_AQUEUE)
        message("WARNING: could not find AudioQueue. (This is normal on OS X 10.4)")
    endif(NOT SUPPORT_AQUEUE)
endif(WANT_AQUEUE AND MACOSX)

if(SUPPORT_AQUEUE)
    set(ALLEGRO_CFG_KCM_AQUEUE 1)
    list(APPEND AUDIO_SOURCES aqueue.m)
    list(APPEND AUDIO_LIBRARIES ${AUDIO_TOOLBOX_LIB})
    set(SUPPORT_AUDIO 1)
endif(SUPPORT_AQUEUE)

if(WANT_OPENAL)
    find_package(OpenAL)
    mark_as_advanced(OPENAL_INCLUDE_DIR OPENAL_LIBRARY)
    if(OPENAL_FOUND)
        set(SUPPORT_OPENAL 1)
    endif(OPENAL_FOUND)
endif(WANT_OPENAL)

if(SUPPORT_OPENAL)
    set(ALLEGRO_CFG_KCM_OPENAL 1)
    list(APPEND AUDIO_SOURCES openal.c)
    list(APPEND AUDIO_LIBRARIES ${OPENAL_LIBRARY})
    include_directories(SYSTEM ${OPENAL_INCLUDE_DIR})
    set(SUPPORT_AUDIO 1)
endif(SUPPORT_OPENAL)

configure_file(
    allegro5/internal/aintern_audio_cfg.h.cmake
    ${CMAKE_BINARY_DIR}/include/allegro5/internal/aintern_audio_cfg.h
    )

if(NOT SUPPORT_AUDIO)
    message("WARNING: allegro_audio wanted but no supported backend found")
    return()
endif(NOT SUPPORT_AUDIO)

# Let examples know that audio is supported.
set(SUPPORT_AUDIO 1 PARENT_SCOPE)

add_our_library(allegro_audio
    "${AUDIO_SOURCES};${AUDIO_INCLUDE_FILES}"
    "-DALLEGRO_KCM_AUDIO_SRC"
    "${ALLEGRO_LINK_WITH};${AUDIO_LIBRARIES}"
    )

set_our_framework_properties(allegro_audio AllegroAudio-${ALLEGRO_SOVERSION})

install_our_library(allegro_audio)
install_our_headers(${AUDIO_INCLUDE_FILES})

set(AUDIO_LINK_WITH allegro_audio PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== addons/color/CMakeLists.txt ===
set(COLOR_SOURCES color.c)

set(COLOR_INCLUDE_FILES
    allegro5/allegro_color.h
    )

set_our_header_properties(${COLOR_INCLUDE_FILES})

add_our_library(allegro_color
    "${COLOR_SOURCES};${COLOR_INCLUDE_FILES}"
    "-DALLEGRO_COLOR_SRC"
    "${ALLEGRO_LINK_WITH}"
    )

set_our_framework_properties(allegro_color AllegroColor-${ALLEGRO_SOVERSION})

install_our_library(allegro_color)
install_our_headers(${COLOR_INCLUDE_FILES})

set(COLOR_LINK_WITH allegro_color PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== addons/font/CMakeLists.txt ===
set(FONT_SOURCES font.c fontbmp.c stdfont.c text.c)

set(FONT_INCLUDE_FILES allegro5/allegro_font.h)

set_our_header_properties(${FONT_INCLUDE_FILES})

add_our_library(allegro_font
    "${FONT_SOURCES};${FONT_INCLUDE_FILES}"
    "-DALLEGRO_FONT_SRC"
    "${ALLEGRO_LINK_WITH}"
    )

set_our_framework_properties(allegro_font AllegroFont-${ALLEGRO_SOVERSION})

install_our_library(allegro_font)
install_our_headers(${FONT_INCLUDE_FILES})

set(FONT_LINK_WITH allegro_font PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vim: set ts=8 sts=4 sw=4 et:

=== addons/image/CMakeLists.txt ===
option(WANT_NATIVE_IMAGE_LOADER "Enable the native platform image loader (if available)" on)

set(IMAGE_SOURCES bmp.c iio.c pcx.c tga.c)
set(IMAGE_INCLUDE_FILES allegro5/allegro_image.h)

set_our_header_properties(${IMAGE_INCLUDE_FILES})

# Accumulate these.
set(IMAGE_LIBRARIES)
set(IMAGE_DEFINES)

# ALLEGRO_CFG_IIO_HAVE_* are the available libraries.
# ALLEGRO_CFG_IIO_SUPPORT_* are the supported formats.

# First look for native libraries and mark any supported image
# type as found, so that the associated third party libraries 
# don't need to be used.

if(WANT_NATIVE_IMAGE_LOADER)
    set(ALLEGRO_CFG_WANT_NATIVE_IMAGE_LOADER 1)

    if(WIN32)
        find_package(GDIPLUS)
        if(GDIPLUS_FOUND)
            set(CMAKE_REQUIRED_DEFINITIONS -DGDIPLUS_LOWERCASE=${GDIPLUS_LOWERCASE})
            set(CMAKE_REQUIRED_INCLUDES ${GDIPLUS_INCLUDE_DIR})
            set(CMAKE_REQUIRED_LIBRARIES ${GDIPLUS_LIBRARY})
            check_cxx_source_compiles("
                #include <windows.h>
                #include <objidl.h>
                #if GDIPLUS_LOWERCASE
                    #include <gdiplus.h>
                #else
                    #include <GdiPlus.h>
                #endif
                using namespace Gdiplus;
                int main(void)
                {
                    int pf = PixelFormat32bppARGB;
                    return 0;
                }
                "
                SUPPORT_GDIPLUS)
        endif(GDIPLUS_FOUND)
        if(SUPPORT_GDIPLUS)
            set(ALLEGRO_CFG_IIO_HAVE_GDIPLUS 1)
            set(ALLEGRO_CFG_IIO_HAVE_GDIPLUS_LOWERCASE_H ${GDIPLUS_LOWERCASE})
            set(ALLEGRO_CFG_IIO_SUPPORT_PNG 1)
            set(ALLEGRO_CFG_IIO_SUPPORT_JPG 1)
            list(APPEND IMAGE_SOURCES gdiplus.cpp)
            list(APPEND IMAGE_LIBRARIES ${GDIPLUS_LIBRARIES})
            if(MINGW)
                list(APPEND IMAGE_LIBRARIES uuid)
            endif(MINGW)
            list(APPEND IMAGE_DEFINES ${GDIPLUS_DEFINITIONS})
            include_directories(SYSTEM ${GDIPLUS_INCLUDE_DIR})            
        else(SUPPORT_GDIPLUS)
            message("WARNING: cannot use GDI+. Will try other libraries.")
        endif(SUPPORT_GDIPLUS)
    endif(WIN32)

    if (MACOSX)
        set(ALLEGRO_CFG_IIO_SUPPORT_PNG 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_JPG 1)
        list(APPEND IMAGE_SOURCES macosx.m)
    endif(MACOSX)

    if(IPHONE)
        list(APPEND IMAGE_SOURCES iphone.m)
    endif(IPHONE)
endif(WANT_NATIVE_IMAGE_LOADER)

# Now look for third party libraries to handle the unsupported formats

if(WANT_IMAGE_PNG AND NOT ALLEGRO_CFG_IIO_SUPPORT_PNG)
    find_package(PNG)
    if(PNG_FOUND)
        # HAVE_PNG means libpng is available (and should be used)
        set(ALLEGRO_CFG_IIO_HAVE_PNG 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_PNG 1)
        list(APPEND IMAGE_SOURCES png.c)
        list(APPEND IMAGE_LIBRARIES ${PNG_LIBRARIES})
        list(APPEND IMAGE_DEFINES ${PNG_DEFINITIONS})
        include_directories(SYSTEM ${PNG_INCLUDE_DIR})
    else(PNG_FOUND)
        message("WARNING: libpng not found, disabling support")
    endif(PNG_FOUND)
endif(WANT_IMAGE_PNG AND NOT ALLEGRO_CFG_IIO_SUPPORT_PNG)

if(WANT_IMAGE_JPG AND NOT ALLEGRO_CFG_IIO_SUPPORT_JPG)
    find_package(JPEG)
    if(JPEG_FOUND AND MINGW)
        set(CMAKE_REQUIRED_INCLUDES ${JPEG_INCLUDE_DIR})
        check_c_source_compiles("
            #include <stdio.h>
            #include <windows.h>
            #include <jpeglib.h>
            #include <jerror.h>
            int main(void) {
                return 0;
            }"
            JPEG_COMPILES)
        set(CMAKE_REQUIRED_INCLUDES)
        set(SUPPORT_JPEG ${JPEG_COMPILES})
    else()
        set(SUPPORT_JPEG ${JPEG_FOUND})
    endif()
    if(SUPPORT_JPEG)
        # HAVE_JPG means libjpeg is available (and should be used)
        set(ALLEGRO_CFG_IIO_HAVE_JPG 1)
        set(ALLEGRO_CFG_IIO_SUPPORT_JPG 1)
        list(APPEND IMAGE_SOURCES jpg.c)
        list(APPEND IMAGE_LIBRARIES ${JPEG_LIBRARIES})
        list(APPEND IMAGE_DEFINES ${JPEG_DEFINITIONS})
        list(APPEND IMAGE_INCLUDE_DIRECTORIES ${JPEG_INCLUDE_DIR})
        include_directories(SYSTEM ${JPEG_INCLUDE_DIR})
    else()
        if(MINGW AND JPEG_FOUND AND NOT JPEG_COMPILES)
            message("WARNING: libjpeg found but the headers appear to "
                "conflict with your MinGW headers, so disabling support. "
                "Try a later version.")
        else()
            message("WARNING: libjpeg not found, disabling support")
        endif()
    endif()
endif(WANT_IMAGE_JPG AND NOT ALLEGRO_CFG_IIO_SUPPORT_JPG)

configure_file(
    allegro5/internal/aintern_image_cfg.h.cmake
    ${CMAKE_BINARY_DIR}/include/allegro5/internal/aintern_image_cfg.h
    )

add_our_library(allegro_image
    "${IMAGE_SOURCES};${IMAGE_INCLUDE_FILES}"
    "-DALLEGRO_IIO_SRC"
    "${ALLEGRO_LINK_WITH};${IMAGE_LIBRARIES}"
    )

set_our_framework_properties(allegro_image AllegroImage-${ALLEGRO_SOVERSION})

install_our_library(allegro_image)
install_our_headers(${IMAGE_INCLUDE_FILES})

set(IMAGE_LINK_WITH allegro_image PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== addons/main/CMakeLists.txt ===
if(MACOSX)
    set(SOURCES osx_main.m)
    set(SUPPORT_ALLEGRO_MAIN 1)
endif(MACOSX)

if(NOT SUPPORT_ALLEGRO_MAIN)
    set(SOURCES generic_main.c)
    set(SUPPORT_ALLEGRO_MAIN 1)
endif(NOT SUPPORT_ALLEGRO_MAIN)

add_our_library(allegro_main
   "${SOURCES}"
   "-DALLEGRO_SRC"
   "${ALLEGRO_LINK_WITH}"
   )

set_our_framework_properties(allegro_main AllegroMain-${ALLEGRO_SOVERSION})

install_our_library(allegro_main)

set(SUPPORT_ALLEGRO_MAIN 1 PARENT_SCOPE)
set(ALLEGRO_MAIN_LINK_WITH allegro_main PARENT_SCOPE)

# vim: set sts=4 sw=4 et:

=== addons/memfile/CMakeLists.txt ===

set(MEMFILE_SOURCES memfile.c)

set(MEMFILE_INCLUDE_FILES allegro5/allegro_memfile.h)

set_our_header_properties(${MEMFILE_INCLUDE_FILES})

add_our_library(allegro_memfile
   "${MEMFILE_SOURCES};${MEMFILE_INCLUDE_FILES}"
   "-DALLEGRO_MEMFILE_SRC"
   "${ALLEGRO_LINK_WITH}"
   )

set_our_framework_properties(allegro_memfile AllegroMemfile-${ALLEGRO_SOVERSION})

install_our_library(allegro_memfile)
install_our_headers(${MEMFILE_INCLUDE_FILES})

set(MEMFILE_LINK_WITH allegro_memfile PARENT_SCOPE)

#-----------------------------------------------------------------------------#
# vi: set ts=8 sts=4 sw=4 et:

=== debian/changelog ===
allegro5 (2:5.0.10-2) unstable; urgency=low

  [ Andreas Rönnquist ]
  * Add pandoc-data to Build-Depends-Indep (Closes: #724157)

  [ Tobias Hansen ]
  * Make Vcs-* fields in debian/control canonical.

 -- Tobias Hansen <thansen@debian.org>  Mon, 23 Sep 2013 23:22:29 +0200

allegro5 (2:5.0.10-1) unstable; urgency=low

  * New upstream release.
  * Delete patch fix-make-converters-py.patch,
    was applied upstream.
  * Remove unused lintian override hyphen-used-as-minus-sign.

 -- Tobias Hansen <thansen@debian.org>  Mon, 17 Jun 2013 22:20:03 +0200

allegro5 (2:5.0.9-1) unstable; urgency=low

  * New upstream release.
  * Add patch fix-make-converters-py.patch:
    - Fixes make_converters.py after enum ALLEGRO_PIXEL_FORMAT was
      moved from bitmap.h to color.h.
  * Refresh patches:
    - fix-fallback-path-max.patch
    - fix-manpage-generation-script.patch
  * Add new symbols to symbols files:
    - liballegro-dialog5.0.symbols:
      al_init_native_dialog_addon
      al_shutdown_native_dialog_addon
    - liballegro5.0.symbols:
      al_set_display_icons
  * Add epoch to version numbers in symbol files.
  * Install new headers.
  * Bump Standards-Version to 3.9.4 (no changes needed).

 -- Tobias Hansen <thansen@debian.org>  Sun, 24 Feb 2013 18:03:26 +0100

=== debian/control ===
Source: allegro5
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Tobias Hansen <thansen@debian.org>, Andreas Rönnquist <gusnan@gusnan.se>
Build-Depends: debhelper (>= 9),
               cmake,
               libdumb1-dev,
               libflac-dev,
               libfreetype6-dev,
               libgl1-mesa-dev,
               libglu1-mesa-dev,
               libgtk2.0-dev,
               libjpeg8-dev,
               libopenal-dev,
               libphysfs-dev,
               libpng12-dev,
               libpulse-dev,
               libvorbis-dev,
               libxext-dev,
               libxxf86vm-dev,
               libxrandr-dev,
               libxinerama-dev,
               libxpm-dev,
               ttf-dejavu-core,
               python,
               indent
Build-Depends-Indep: pandoc, pandoc-data (>= 1.11.1-4) | pandoc (<< 1.11.1-4)
Standards-Version: 3.9.4
Section: libs
Homepage: http://liballeg.org/
Vcs-Git: git://anonscm.debian.org/pkg-games/allegro5.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/allegro5.git;a=summary

Package: liballegro5.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: portable library for cross-platform game and multimedia development
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro5.0 (= ${binary:Version}),
         libc-dev,
         libgl1-mesa-dev,
         libglu1-mesa-dev,
         libice-dev,
         libsm-dev,
         libx11-dev,
         libxcursor-dev,
         libxext-dev,
         libxinerama-dev,
         libxpm-dev,
         libxrandr-dev
Conflicts: liballegro-dev, liballegro4-dev
Recommends: liballegro-acodec5-dev,
            liballegro-audio5-dev,
            liballegro-dialog5-dev,
            liballegro-image5-dev,
            liballegro-physfs5-dev,
            liballegro-ttf5-dev
Suggests: allegro5-doc
Description: development files for the Allegro 5 library
 This package is needed to build programs using the Allegro 5 library.
 Contains header files.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-acodec5.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends},
         liballegro5.0 (= ${binary:Version})
Description: audio codec addon for the Allegro 5 library
 This package provides the audio codec addon for the Allegro 5 library.
 This addon allows you to load audio sample formats.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-acodec5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-acodec5.0 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libopenal-dev,
         libpulse-dev,
         libdumb1-dev,
         libflac-dev,
         libvorbis-dev
Description: header files for the Allegro 5 audio codec addon
 This package is required to build programs that use the Allegro 5 audio
 codec addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-audio5.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.0 (= ${binary:Version})
Description: audio addon for the Allegro 5 library
 This package provides the audio addon for the Allegro 5 library. This
 addon allows you to play sounds in your Allegro 5 programs.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-audio5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-audio5.0 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libopenal-dev,
         libpulse-dev 
Description: header files for the Allegro 5 audio addon
 This package is required to build programs that use the Allegro 5 audio
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-dialog5.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.0 (= ${binary:Version})
Description: dialog addon for the Allegro 5 library
 This package provides the dialog addon for the Allegro 5 library. This
 addon allows you to show dialog boxes.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-dialog5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-dialog5.0 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libgtk2.0-dev
Description: header files for the Allegro 5 dialog addon
 This package is required to build programs that use the Allegro 5 dialog
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-image5.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.0 (= ${binary:Version})
Description: image addon for the Allegro 5 library
 This package provides the image addon for the Allegro 5 library. Provides
 support for loading image file formats.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-image5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-image5.0 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libjpeg8-dev,
         libpng12-dev
Description: header files for the Allegro 5 image addon
 This package is required to build programs that use the Allegro 5 image
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-physfs5.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.0 (= ${binary:Version})
Description: physfs addon for the Allegro 5 library
 This package provides the physfs addon for the Allegro 5 library. This
 addon provides an interface to the PhysicsFS library, allowing you to
 mount virtual file-systems (e.g., archives) and access files as if they
 were physically on the file-system.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-physfs5-dev
Priority: extra
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         liballegro-physfs5.0 (= ${binary:Version}),
         liballegro5-dev (= ${binary:Version}),
         libphysfs-dev
Description: header files for the Allegro 5 physfs addon
 This package is required to build programs that use the Allegro 5 physfs
 addon.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still
 occupies the same niche and retains a familiar style.

Package: liballegro-ttf5.0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
         liballegro5.0 (= ${binary:Version})
Description: TTF addon for the Allegro 5 library
 This package provides the TTF addon for the Allegro 5 library. This addon
 allows you to load and use TTF fonts in your Allegro 5 programs.
 .
 Allegro is a cross-platform library intended for use in computer games
 and other types of multimedia programming. Allegro 5 is the latest major
 revision of the library, designed to take advantage of modern hardware
 (e.g. hardware acceleration using 3D cards) and operating systems.
 Although it is not backwards compatible with earlier versions, it still

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# Use this variable to allow options passed to cmake to be overridable.
# WANT_EXAMPLES is set to ON only to check if they build successfully,
# as their source is shipped in the doc package.
DEB_CMAKE_OPTIONS ?= -DCMAKE_VERBOSE_MAKEFILE=ON \
		-DCMAKE_INSTALL_PREFIX="/usr" \
		-DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
                -DWANT_DEMO=OFF \
                -DWANT_EXAMPLES=ON \
                -DWANT_DOCS=ON \
                -DWANT_DOCS_HTML=ON \
                -DWANT_DOCS_MAN=ON

%:
	dh $@ --builddirectory=build --parallel

override_dh_auto_configure:
# Delete possibly non-free images/music.
	rm -rf examples/data/haiku demos
# Delete precompiled files.
	rm -rf docs/man/ docs/html/
	rm examples/data/DejaVuSans.*
	rm addons/audio/kcm_mixer_helpers.inc
	rm include/allegro5/opengl/GLext/*gl*_ext_alias.h
	rm src/convert.c include/allegro5/internal/aintern_convert.h
	rm src/scanline_drawers.*
	rm addons/primitives/directx_shaders.c
# Regenerate generated files.
	misc/regenerate.sh
	dh_auto_configure -- $(DEB_CMAKE_OPTIONS)

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/allegro5/platform
	mv debian/tmp/usr/include/allegro5/platform/alplatf.h debian/tmp/usr/include/$(DEB_HOST_MULTIARCH)/allegro5/platform/alplatf.h
	sed -i 's@Cflags: -I$${includedir}@Cflags: -I$${includedir}/$(DEB_HOST_MULTIARCH)@' debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig/allegro-*.pc

override_dh_auto_test:
	cd build && tests/test_driver --no-display ../tests/test_*.ini

override_dh_installchangelogs:
	dh_installchangelogs CHANGES-5.0.txt

override_dh_installexamples-indep:
	dh_installexamples
# Delete haiku example, because we are not shipping its data.
	rm debian/allegro5-doc/usr/share/doc/allegro5-doc/examples/ex_haiku.c
# Delete examples intended for other platforms.
	rm debian/allegro5-doc/usr/share/doc/allegro5-doc/examples/ex_gp2xwiz.c
	rm debian/allegro5-doc/usr/share/doc/allegro5-doc/examples/ex_iphone.c
# Fix permissions
	find debian/allegro5-doc/usr/share/doc/allegro5-doc/examples -type f -exec chmod 644 \{\} \+
